Bug 1020203 - socat: configure checks fail with some compilers
socat: configure checks fail with some compilers
Status: MODIFIED
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: socat (Show other bugs)
7.0
All Linux
medium Severity medium
: rc
: ---
Assigned To: Paul Wouters
BaseOS QE Security Team
:
Depends On:
Blocks: 1019961 1085024
  Show dependency treegraph
 
Reported: 2013-10-17 05:32 EDT by Florian Weimer
Modified: 2018-03-21 21:37 EDT (History)
3 users (show)

See Also:
Fixed In Version: 1.7.3.1-1
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Florian Weimer 2013-10-17 05:32:02 EDT
socat specifies -Werror when running some of its configure checks, and uses code that generates warnings (which are turned into errors).  This is extremely brittle because the code snippets used for checking tend to generate other warnings as well, rendering the checks ineffective.

An example is the AC_BASIC_TYPE macro below.  Some compilers warn about the useless comparison &u==&v, it seems.  GCC might do so eventually, too, so this is really brittle and should be fixed.

dnl find what physical type (basic C type) is equivalent to the given type.
dnl arg1: include file(s)
dnl arg2: type name
dnl arg3: output variable
dnl arg4: cache variable (might be constructed automatically)
dnl   output values: 1..short, 2..unsigned short, 3..int, 4..u-int,
dnl                  5..long, 6..u-long; others not yet supported
define(AC_BASIC_TYPE,[
AC_CACHE_CHECK(for equivalent simple type of $2, $4,
[CFLAGS1="$CFLAGS"; CFLAGS="$ERRONWARN $(echo "$CFLAGS1" | sed -e 's@-Wall@@g')"
 AC_TRY_COMPILE([$1],[$2 u; short v; &u==&v;],
 [$4="1 /* short */"],
 [AC_TRY_COMPILE([$1],[$2 u; unsigned short v; &u==&v;],
  [$4="2 /* unsigned short */"],
  [AC_TRY_COMPILE([$1],[$2 u; int v; &u==&v;],
   [$4="3 /* int */"],
   [AC_TRY_COMPILE([$1],[$2 u; unsigned int v; &u==&v;],
    [$4="4 /* unsigned int */"],
    [AC_TRY_COMPILE([$1],[$2 u; long v; &u==&v;],
     [$4="5 /* long */"],
     [AC_TRY_COMPILE([$1],[$2 u; unsigned long v; &u==&v;],
      [$4="6 /* unsigned long */"],
      [AC_TRY_COMPILE([$1],[$2 u; long long v; &u==&v;],
       [$4="7 /* long long */"],
       [AC_TRY_COMPILE([$1],[$2 u; unsigned long long v; &u==&v;],
        [$4="8 /* unsigned long long */"],
        [$4="0 /* unknown, taking default */"
]) ]) ]) ]) ]) ]) ]) ])
 CFLAGS="$CFLAGS1" ])
AC_DEFINE_UNQUOTED($3, ${$4})
])
Comment 2 Gerhard 2014-03-10 17:04:58 EDT
Has been significantly improved in upstream release 1.7.2.4
Comment 5 Paul Wouters 2016-04-28 00:32:28 EDT
Florian: can you check 1.7.3.1 and let me know if that solves it satisfactory? Since I'd like to rebase to that version
Comment 6 Florian Weimer 2016-04-28 01:35:25 EDT
(In reply to Paul Wouters from comment #5)
> Florian: can you check 1.7.3.1 and let me know if that solves it
> satisfactory? Since I'd like to rebase to that version

I don't see -Werror in configure checks with socat 1.7.3.1.

Note You need to log in before you can comment on or make changes to this bug.